/*
 * wmmge header file
 *
 *		wmmge dockapp for windowMaker
 *
 * Copyright (C) 2001 bennyben (benoit bourdin) 
 *   <bennybben@caramail.com>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */


#ifndef _WMMGE_H_
#define _WMMGE_H_

#include "../wmgeneral/wmgeneral.h"

#ifndef bool
	typedef unsigned char bool;
#	define true	1
#	define false	0
#endif

#define WMMGE_VERSION	0.3


#define WMMGE_MAX_CLOCK	999999

#define WMMGE_ALERT_DELAY	60
#define WMMGE_MAX_CONSO		80
#define WMMGE_MIN_LOAD		20

#define WMMGE_GETTIME_CMD	"sendups -cmd Bn | cut -d'[' -f3 | cut -d']' -f1"
#define WMMGE_GETSTATUS_CMD	"sendups -cmd Ss | cut -d'[' -f3 | cut -c 1"
#define WMMGE_GETLOAD_CMD	"sendups -cmd Bl | cut -d'[' -f3 | cut -d']' -f1"
#define WMMGE_GETCONSO_CMD	"sendups -cmd Ll | cut -d'[' -f3 | cut -d']' -f1"
#define WMMGE_MAX_CMD		100

#define WMMGE_TMP_TIME_FILE	"/tmp/.__wmmge-time__"
#define WMMGE_TMP_STATUS_FILE	"/tmp/.__wmmge-status__"
#define WMMGE_TMP_LOAD_FILE	"/tmp/.__wmmge-load__"
#define WMMGE_TMP_CONSO_FILE	"/tmp/.__wmmge-conso__"

#define WMMGE_READ_MAX		10

#define WMMGE_FILENAME_MAX	60
#define WMMGE_PATH_MAX		200
 
	/* structures */
struct wmmge_events
{
	int event;
	void (*exec)();
};

	/* global variables */
extern char *wmmge_sendps;
extern unsigned int wmmge_remaining_time;
extern unsigned int wmmge_clock;
extern bool wmmge_powerfail;
extern unsigned int wmmge_load;
extern unsigned int wmmge_conso;

	/* constants */
extern const int wmmge_refresh_delay;
	/* tables */
extern const struct wmmge_events WMMGE_EVENTS[];
extern rckeys WMMGE_CONFIG_KEYS[];


	/* main functons */
void get_config();
void process_events();
void refresh_display();
void get_infos();
int get_info(const char *cmd, const char *tmp_file);
void verif_infos();
	/* callbacks */
void wmmge_OnExpose();
void wmmge_OnDestroyNotify();
void wmmge_OnButtonPress();
void wmmge_OnButtonRelease();
	/* display functions */
	/* first view */
void v1_disp_remaining_time(bool flash);
void v1_disp_back(bool flash);
void v1_disp_figure(unsigned int n,unsigned int x, unsigned int y, bool flash);
void v1_disp_socket(bool flash);
void v1_disp_ups();
	/* second view */
void v2_disp_back();
void v2_disp_bar(unsigned int type, unsigned int n, unsigned int x, unsigned int y);
void v2_disp_figure(unsigned int n,unsigned int x, unsigned int y);
void v2_disp_remaining_time();
void v2_disp_load(bool flash);
void v2_disp_conso(bool flash);

#endif
